'Podsuch I2C
'Andrzej Jabonski
'atom1477@wp.pl

'Ustawienia bezpiecznikw:    Crystal Clock - High Frequency  (CKSEL - 1111, CKOPT - 0)

$regfile = "M8def.dat"
$crystal = 16000000
$hwstack = 8
$baud = 19200
'-------------------------------------------------------------------------------
Dim Dane(980) As Byte
'-------------------------------------------------------------------------------
Scl Alias Pind.4
Sda Alias Pind.2

Led1 Alias Portc.5                                          'ta    - Buffer Full
Led2 Alias Portc.4                                          'Czerwona - Zawieszenie transmisji
'-------------------------------------------------------------------------------
Const Crc8_polynominal = &B10001101                         'CRC-8-CCITT
'-------------------------------------------------------------------------------
On Int0 Int0_handler Nosave
On Int1 Int1_handler Nosave
On Urxc Uart_receive_int Nosave
'-------------------------------------------------------------------------------
Portb = &B00000000
Portc = &B00000000
Portd = &B00011100

$include "Nopy.bas"

Config Portb = &B00000000
Config Portc = &B00110000
Config Portd = &B00000000



Config Com1 = Dummy , Synchrone = 0 , Parity = Odd , Stopbits = 2 , Databits = 8 , Clockpol = 0


ldi R16, &B00001110                                         'Config Int0 = Falling, Config Int1 = Rising
!Out MCUCR, R16



!Label_Start:
Enable Urxc


Loadadr Dane(1) , X


clr R17
ldi R16, 204
!Loop_clear_ram:
    st X+, R17
    st X+, R17
    st X+, R17
    st X+, R17
    st X+, R17
dec R16
brne Loop_clear_ram



Loadadr Dane(1) , X



ldi R16, &H10                                               'Start
ldi R17, &H20                                               'Stop
ldi R18, &H40                                               'Data

                                                            '&H80 - Buffer_Full


ldi R22, &B00000000                                         'LED2 = 0
ldi R23, &B00010000                                         'LED2 = 1




ldi R20, &B00000001



ldi R24, &B11000000                                         'Kasowanie flag przerwa INT0 i INT1
!Out GIFR, R24


ldi R24, &B11000000                                         'Enable Int0, Enable Int1
!Out GICR, R24


!Label_wait_to_start:
Enable Interrupts

Do
Loop




!Label_start_receiving_data:
Enable Interrupts



  '===========================
  !Wait_for_0_0:
  sbic Pind, 4
    jmp Wait_for_0_0



  !Wait_for_1_0:
  sbis Pind, 4
    jmp Wait_for_1_0



  In R19, PinD
  bst R19, 2
  bld R20, 7
  '===========================
  !Wait_for_0_1:
  sbic Pind, 4
    jmp Wait_for_0_1



  !Wait_for_1_1:
  sbis Pind, 4
    jmp Wait_for_1_1



  In R19, PinD
  bst R19, 2
  bld R20, 6
  '===========================
Do
  !Wait_for_0_2:
  sbic Pind, 4
    jmp Wait_for_0_2



  !Wait_for_1_2:
  sbis Pind, 4
    jmp Wait_for_1_2



  In R19, PinD
  bst R19, 2
  bld R20, 5
  '===========================
  !Wait_for_0_3:
  sbic Pind, 4
    jmp Wait_for_0_3



  !Wait_for_1_3:
  sbis Pind, 4
    jmp Wait_for_1_3



  In R19, PinD
  bst R19, 2
  bld R20, 4
  '===========================
  !Wait_for_0_4:
  sbic Pind, 4
    jmp Wait_for_0_4



  !Wait_for_1_4:
  sbis Pind, 4
    jmp Wait_for_1_4



  In R19, PinD
  bst R19, 2
  bld R20, 3
  '===========================
  !Wait_for_0_5:
  sbic Pind, 4
    jmp Wait_for_0_5



  !Wait_for_1_5:
  sbis Pind, 4
    jmp Wait_for_1_5



  In R19, PinD
  bst R19, 2
  bld R20, 2
  '===========================
  !Wait_for_0_6:
  sbic Pind, 4
    jmp Wait_for_0_6



  !Wait_for_1_6:
  sbis Pind, 4
    jmp Wait_for_1_6



  In R19, PinD
  bst R19, 2
  bld R20, 1
  '===========================
  !Wait_for_0_7:
  sbic Pind, 4
    jmp Wait_for_0_7



  !Wait_for_1_7:
  sbis Pind, 4
    jmp Wait_for_1_7



  In R21, PinD
  '===========================
  !Wait_for_0_8:
  sbic Pind, 4
    jmp Wait_for_0_8



  !Wait_for_1_8:
  sbis Pind, 4
    jmp Wait_for_1_8



  In R19, PinD
  andi R19, &B00000100
  '===========================

  !or R19, R18

  bst R21, 2
  bld R19, 0


  st X+, R19
  st X+, R20






  '===========================
  !Wait_for_0_0b:
  sbic Pind, 4
    jmp Wait_for_0_0b



  !Wait_for_1_0b:
  sbis Pind, 4
    jmp Wait_for_1_0b



  In R19, PinD
  bst R19, 2
  bld R20, 7



  lds R24, 1113                                             '{Dane+1017}
  cpi R24, 0
  brne Koniec
  '===========================
  !Wait_for_0_1b:
  sbic Pind, 4
    jmp Wait_for_0_1b



  !Wait_for_1_1b:
  sbis Pind, 4
    jmp Wait_for_1_1b



  In R19, PinD
  bst R19, 2
  bld R20, 6
  '===========================
Loop

!Koniec:
ldi R24, &B00000000                                         'Disable Int0, Disable Int1
!Out GICR, R24

Enable Interrupts

ldi R24, &H80
st X, R24

Led1 = 1



!Label_Stop:
Enable Interrupts


Do
Loop
'-------------------------------------------------------------------------------
Int0_handler:
  sbis Pind, 4
    reti


'  st X, R16
  st X, R16
  st X+, R16

  pop R0
  pop R0


  !Out PORTC, R23                                           'Led2 = 1


  lds R24, 1113                                             '{Dane+1017}
  cpi R24, 0
  brne Koniec
jmp Label_start_receiving_data
'-------------------------------------------------------------------------------
Int1_handler:
  sbis Pind, 4
    reti

'  st X, R17
  st X, R17
  st X+, R17

  pop R0
  pop R0


  !Out PORTC, R22                                           'Led2 = 0


  lds R24, 1113                                             '{Dane+1017}
  cpi R24, 0
  brne Koniec
jmp Label_wait_to_start
'-------------------------------------------------------------------------------
Uart_receive_int:
  In R16, UDR

  Led1 = 0
  Led2 = 0

  ldi R24, &B00000000                                       'Disable Int0, Disable Int1
  !Out GICR, R24


  cpi R16, &H55
  breq Start_receiving_command
      Loadadr Dane(1) , X


      pop R16
      pop R9
      andi R16, &B00000111
      mov R8, R16


      ldi R17, 45
      ldi R18, 204
      !Loop_send_buffer:
          ld R16, X+
          Gosub Uart_send
          add R17, R16

          ld R16, X+
          Gosub Uart_send
          add R17, R16

          ld R16, X+
          Gosub Uart_send
          add R17, R16

          ld R16, X+
          Gosub Uart_send
          add R17, R16

          ld R16, X+
          Gosub Uart_send
          add R17, R16
      dec R18
      brne Loop_send_buffer





      mov R16, R8
      Gosub Uart_send
      add R17, R16

      mov R16, R9
      Gosub Uart_send
      add R17, R16




      mov R16, R19
      Gosub Uart_send
      add R17, R16

      mov R16, R20
      Gosub Uart_send
      add R17, R16

      mov R16, R21
      Gosub Uart_send
      add R17, R16




      mov R16, R17
      Gosub Uart_send


      jmp Label_Stop
  !Start_receiving_command:
      pop R8
      pop R9

      jmp Label_Start
'-------------------------------------------------------------------------------
Uart_send:
    !USART_Transmit:
    sbis UCSRA, UDRE
    rjmp USART_Transmit

    !Out UDR, R16
Return
'-------------------------------------------------------------------------------
'(Calculate_crc:                                              'Reverse CRC
  ldi R20, 6                                                'Licznik bajtw
  Loadadr Dane(1) , X



  ser R16


  !Crc8_Loop:
    ld R17, X+

    ldi R18, 8
    !Crc8_Loop_Byte:
      bst R16, 7
      bld R19, 0
      eor R19, R17

      rol R16

      cbr R16, 1

      lsr R17

      ror R19
      brcc CRC8_No_XOR
        ldi R19, CRC8_polynominal
        eor R16, R19
      !Crc8_No_XOR:

      dec R18
    brne CRC8_Loop_Byte


    dec R20
  brne CRC8_Loop


  com R16
Return                                                      ')
')
'-------------------------------------------------------------------------------
Uart_printbin:
    Printbin Dane(1)
Return
'-------------------------------------------------------------------------------